var NAVTREE =
[
  [ "FLTK 1.3.2", "index.html", [
    [ "FLTK Programming Manual", "index.html", null ],
    [ "Preface", "preface.html", [
      [ "Organization", "preface.html#preface_organisation", null ],
      [ "Conventions", "preface.html#preface_conventions", null ],
      [ "Abbreviations", "preface.html#preface_abbreviations", null ],
      [ "Copyrights and Trademarks", "preface.html#preface_copyrights", null ]
    ] ],
    [ "Introduction to FLTK", "intro.html", [
      [ "History of FLTK", "intro.html#intro_history", null ],
      [ "Features", "intro.html#intro_features", null ],
      [ "Licensing", "intro.html#intro_licensing", null ],
      [ "What Does \"FLTK\" Mean?", "intro.html#intro_what", null ],
      [ "Building and Installing FLTK Under UNIX and Apple OS X", "intro.html#intro_unix", null ],
      [ "Building FLTK Under Microsoft Windows", "intro.html#intro_windows", [
        [ "GNU toolsets (Cygwin or MinGW) hosted on Windows", "intro.html#intro_cygwin_mingw", null ],
        [ "Using the Visual C++ DLL Library", "intro.html#intro_visualcpp", null ]
      ] ],
      [ "Internet Resources", "intro.html#intro_internet", null ],
      [ "Reporting Bugs", "intro.html#intro_reporting", null ]
    ] ],
    [ "FLTK Basics", "basics.html", [
      [ "Writing Your First FLTK Program", "basics.html#basics_writing", [
        [ "Creating the Widgets", "basics.html#basics_creating", null ],
        [ "Creating Widget hierarchies", "basics.html#basics_hierarchies", null ],
        [ "Get/Set Methods", "basics.html#basics_getset", null ],
        [ "Redrawing After Changing Attributes", "basics.html#basics_redrawing", null ],
        [ "Labels", "basics.html#basics_labels", null ],
        [ "Showing the Window", "basics.html#basics_showing", null ],
        [ "The Main Event Loop", "basics.html#basics_eventloop", null ]
      ] ],
      [ "Compiling Programs with Standard Compilers", "basics.html#basics_standard_compiler", null ],
      [ "Compiling Programs with Makefiles", "basics.html#basics_makefile", null ],
      [ "Compiling Programs with Microsoft Visual C++", "basics.html#basics_visual_cpp", null ],
      [ "Naming", "basics.html#basics_naming", null ],
      [ "Header Files", "basics.html#basics_headerfiles", null ]
    ] ],
    [ "Common Widgets and Attributes", "common.html", [
      [ "Buttons", "common.html#common_buttons", null ],
      [ "Text", "common.html#common_text", null ],
      [ "Valuators", "common.html#common_valuators", null ],
      [ "Groups", "common.html#common_groups", null ],
      [ "Setting the Size and Position of Widgets", "common.html#common_sizeposition", null ],
      [ "Colors", "common.html#common_colors", null ],
      [ "Box Types", "common.html#common_boxtypes", [
        [ "Making Your Own Boxtypes", "common.html#common_custom_boxtypes", null ]
      ] ],
      [ "Labels and Label Types", "common.html#common_labels", null ],
      [ "Callbacks", "common.html#common_callbacks", null ],
      [ "Shortcuts", "common.html#common_shortcuts", null ]
    ] ],
    [ "Designing a Simple Text Editor", "editor.html", [
      [ "Determining the Goals of the Text Editor", "editor.html#editor_goals", null ],
      [ "Designing the Main Window", "editor.html#editor_main_window", null ],
      [ "Variables", "editor.html#editor_variables", null ],
      [ "Menubars and Menus", "editor.html#editor_menubars", null ],
      [ "Editing the Text", "editor.html#editor_editing", null ],
      [ "The Replace Dialog", "editor.html#editor_replace_dialog", null ],
      [ "Callbacks", "editor.html#editor_callbacks", [
        [ "changed_cb()", "editor.html#editor_changed_cb", null ],
        [ "copy_cb()", "editor.html#editor_copy_cb", null ],
        [ "cut_cb()", "editor.html#editor_cut_cb", null ],
        [ "delete_cb()", "editor.html#editor_delete_cb", null ],
        [ "find_cb()", "editor.html#editor_find_cb", null ],
        [ "find2_cb()", "editor.html#editor_find2_cb", null ],
        [ "new_cb()", "editor.html#editor_new_cb", null ],
        [ "open_cb()", "editor.html#editor_open_cb", null ],
        [ "paste_cb()", "editor.html#editor_paste_cb", null ],
        [ "quit_cb()", "editor.html#editor_quit_cb", null ],
        [ "replace_cb()", "editor.html#editor_replace_cb", null ],
        [ "replace2_cb()", "editor.html#editor_replace2_cb", null ],
        [ "replall_cb()", "editor.html#editor_replall_cb", null ],
        [ "replcan_cb()", "editor.html#editor_replcan_cb", null ],
        [ "save_cb()", "editor.html#editor_save_cb", null ],
        [ "saveas_cb()", "editor.html#editor_saveas_cb", null ]
      ] ],
      [ "Other Functions", "editor.html#editor_other_functions", [
        [ "check_save()", "editor.html#editor_check_save", null ],
        [ "load_file()", "editor.html#editor_load_file", null ],
        [ "save_file()", "editor.html#editor_save_file", null ],
        [ "set_title()", "editor.html#editor_set_title", null ]
      ] ],
      [ "The main() Function", "editor.html#editor_main_function", null ],
      [ "Compiling the Editor", "editor.html#editor_compiling", null ],
      [ "The Final Product", "editor.html#editor_final_product", null ],
      [ "Advanced Features", "editor.html#editor_advanced_features", [
        [ "Syntax Highlighting", "editor.html#editor_syntax", null ]
      ] ]
    ] ],
    [ "Drawing Things in FLTK", "drawing.html", [
      [ "When Can You Draw Things in FLTK?", "drawing.html#sect_WhenCanYouDraw", null ],
      [ "Drawing Functions", "drawing.html#sect_DrawingFunctions", [
        [ "Boxes", "drawing.html#ssect_Boxes", null ],
        [ "Clipping", "drawing.html#ssect_Clipping", null ]
      ] ],
      [ "Colors", "drawing.html#drawing_colors", [
        [ "Line Dashes and Thickness", "drawing.html#ssect_Lines", null ],
        [ "Drawing Fast Shapes", "drawing.html#ssect_Fast", null ],
        [ "Drawing Complex Shapes", "drawing.html#ssect_Complex", null ],
        [ "Drawing Text", "drawing.html#ssect_Text", null ],
        [ "Fonts", "drawing.html#ssect_Fonts", null ],
        [ "Character Encoding", "drawing.html#ssect_CharacterEncoding", null ],
        [ "Drawing Overlays", "drawing.html#ssect_Overlay", null ]
      ] ],
      [ "Drawing Images", "drawing.html#drawing_images", [
        [ "Direct Image Drawing", "drawing.html#ssect_DirectImageDrawing", null ],
        [ "Direct Image Reading", "drawing.html#ssect_DirectImageReading", null ],
        [ "Image Classes", "drawing.html#ssect_Fl_Image", null ],
        [ "Offscreen Drawing", "drawing.html#ssect_Offscreen", null ]
      ] ]
    ] ],
    [ "Handling Events", "events.html", [
      [ "The FLTK Event Model", "events.html#events_model", null ],
      [ "Mouse Events", "events.html#events_mouse", [
        [ "FL_PUSH", "events.html#events_fl_push", null ],
        [ "FL_DRAG", "events.html#events_fl_drag", null ],
        [ "FL_RELEASE", "events.html#events_fl_release", null ],
        [ "FL_MOVE", "events.html#events_fl_move", null ],
        [ "FL_MOUSEWHEEL", "events.html#events_fl_mousewheel", null ]
      ] ],
      [ "Focus Events", "events.html#events_focus", [
        [ "FL_ENTER", "events.html#events_fl_enter", null ],
        [ "FL_LEAVE", "events.html#events_fl_leave", null ],
        [ "FL_FOCUS", "events.html#events_fl_focus", null ],
        [ "FL_UNFOCUS", "events.html#events_fl_unfocus", null ]
      ] ],
      [ "Keyboard Events", "events.html#events_keyboard", [
        [ "FL_KEYBOARD, FL_KEYDOWN, FL_KEYUP", "events.html#events_fl_keydown", null ],
        [ "FL_SHORTCUT", "events.html#events_fl_shortcut", null ]
      ] ],
      [ "Widget Events", "events.html#events_widget", [
        [ "FL_DEACTIVATE", "events.html#events_fl_deactivate", null ],
        [ "FL_ACTIVATE", "events.html#events_fl_activate", null ],
        [ "FL_HIDE", "events.html#events_fl_hide", null ],
        [ "FL_SHOW", "events.html#events_fl_show", null ]
      ] ],
      [ "Clipboard Events", "events.html#events_clipboard", [
        [ "FL_PASTE", "events.html#events_fl_paste", null ],
        [ "FL_SELECTIONCLEAR", "events.html#events_fl_selectionclear", null ]
      ] ],
      [ "Drag and Drop Events", "events.html#events_dnd", [
        [ "FL_DND_ENTER", "events.html#events_fl_dnd_enter", null ],
        [ "FL_DND_DRAG", "events.html#events_fl_dnd_drag", null ],
        [ "FL_DND_LEAVE", "events.html#events_fl_dnd_leave", null ],
        [ "FL_DND_RELEASE", "events.html#events_fl_dnd_release", null ]
      ] ],
      [ "Other events", "events.html#events_fl_misc", [
        [ "FL_SCREEN_CONFIGURATION_CHANGED", "events.html#events_fl_screen_config", null ],
        [ "FL_FULLSCREEN", "events.html#events_fl_fullscreen", null ]
      ] ],
      [ "Fl::event_*() methods", "events.html#events_event_xxx", null ],
      [ "Event Propagation", "events.html#events_propagation", null ],
      [ "FLTK Compose-Character Sequences", "events.html#events_compose_characters", null ]
    ] ],
    [ "Adding and Extending Widgets", "subclassing.html", [
      [ "Subclassing", "subclassing.html#subclassing_subclassing", null ],
      [ "Making a Subclass of Fl_Widget", "subclassing.html#subclassing_fl_widget", null ],
      [ "The Constructor", "subclassing.html#subclassing_constructor", null ],
      [ "Protected Methods of Fl_Widget", "subclassing.html#subclassing_protected", null ],
      [ "Handling Events", "subclassing.html#subclassing_events", null ],
      [ "Drawing the Widget", "subclassing.html#subclassing_drawing", null ],
      [ "Resizing the Widget", "subclassing.html#subclassing_resizing", null ],
      [ "Making a Composite Widget", "subclassing.html#subclassing_composite", null ],
      [ "Cut and Paste Support", "subclassing.html#subclassing_cutnpaste", null ],
      [ "Drag And Drop Support", "subclassing.html#subclassing_dragndrop", null ],
      [ "Making a subclass of Fl_Window", "subclassing.html#subclassing_fl_window", null ]
    ] ],
    [ "Using OpenGL", "opengl.html", [
      [ "Using OpenGL in FLTK", "opengl.html#opengl_using", null ],
      [ "Making a Subclass of Fl_Gl_Window", "opengl.html#opengl_subclass", [
        [ "Defining the Subclass", "opengl.html#opengl_defining", null ],
        [ "The draw() Method", "opengl.html#opengl_draw", null ],
        [ "The handle() Method", "opengl.html#opengl_handle", null ]
      ] ],
      [ "Using OpenGL in Normal FLTK Windows", "opengl.html#opengl_normal", null ],
      [ "OpenGL Drawing Functions", "opengl.html#opengl_drawing", null ],
      [ "Speeding up OpenGL", "opengl.html#opengl_speed", null ],
      [ "Using OpenGL Optimizer with FLTK", "opengl.html#opengl_optimizer", null ]
    ] ],
    [ "Programming with FLUID", "fluid.html", [
      [ "What is FLUID?", "fluid.html#fluid_what_is_fluid", null ],
      [ "Running FLUID Under UNIX", "fluid.html#fluid_fluid_under_unix", null ],
      [ "Running FLUID Under Microsoft Windows", "fluid.html#fluid_fluid_under_windows", null ],
      [ "Compiling .fl files", "fluid.html#fluid_compiling_fl_files", null ],
      [ "A Short Tutorial", "fluid.html#fluid_tutorial", [
        [ "The CubeView Class", "fluid.html#fluid_cubeview", null ],
        [ "The CubeViewUI Class", "fluid.html#fluid_cubevieui", null ],
        [ "Adding Constructor Initialization Code", "fluid.html#fluid_addconst", null ],
        [ "Generating the Code", "fluid.html#fluid_gencode", null ]
      ] ],
      [ "FLUID Reference", "fluid.html#fluid_references", [
        [ "The Widget Browser", "fluid.html#fluid_browser", null ],
        [ "Menu Items", "fluid.html#fluid_menu_items", null ],
        [ "The Widget Panel", "fluid.html#fluid_widget_panel", null ]
      ] ],
      [ "GUI Attributes", "fluid.html#fluid_widget_attributes", [
        [ "Style Attributes", "fluid.html#fluid_style_attributes", null ],
        [ "C++ Attributes", "fluid.html#fluid_cpp_attributes", null ]
      ] ],
      [ "Selecting and Moving Widgets", "fluid.html#fluid_selecting_moving", null ],
      [ "Image Labels", "fluid.html#fluid_images", null ],
      [ "Internationalization with FLUID", "fluid.html#fluid_i18n", [
        [ "I18N Methods", "fluid.html#fluid_i18n_methods", null ],
        [ "Using GNU gettext for I18N", "fluid.html#fluid_gettext_i18n", null ],
        [ "Using POSIX catgets for I18N", "fluid.html#fluid_catgets_i18n", null ]
      ] ],
      [ "Known limitations", "fluid.html#fluid_limitations", null ]
    ] ],
    [ "Advanced FLTK", "advanced.html", [
      [ "Multithreading", "advanced.html#advanced_multithreading", null ]
    ] ],
    [ "Unicode and UTF-8 Support", "unicode.html", [
      [ "About Unicode, ISO 10646 and UTF-8", "unicode.html#unicode_about", null ],
      [ "Unicode in FLTK", "unicode.html#unicode_in_fltk", null ],
      [ "Illegal Unicode and UTF-8 sequences", "unicode.html#unicode_illegals", null ],
      [ "FLTK Unicode and UTF-8 functions", "unicode.html#unicode_fltk_calls", null ],
      [ "FLTK Unicode versions of system calls", "unicode.html#unicode_system_calls", null ]
    ] ],
    [ "FLTK Enumerations", "enumerations.html", [
      [ "Version Numbers", "enumerations.html#enumerations_versions", null ],
      [ "Events", "enumerations.html#enumerations_events", null ],
      [ "Callback \"When\" Conditions", "enumerations.html#enumerations_when", null ],
      [ "Fl::event_button() Values", "enumerations.html#enumeration_button_values", null ],
      [ "Fl::event_key() Values", "enumerations.html#enumerations_event_key", null ],
      [ "Fl::event_state() Values", "enumerations.html#enumerations_event_state", null ],
      [ "Alignment Values", "enumerations.html#enumerations_alignment", null ],
      [ "Fonts", "enumerations.html#enumerations_fonts", null ],
      [ "Colors", "enumerations.html#enumerations_colors", [
        [ "Color Constants", "enumerations.html#enumerations_color_constants", null ]
      ] ],
      [ "Cursors", "enumerations.html#enumerations_cursors", null ],
      [ "FD \"When\" Conditions", "enumerations.html#enumerations_file_when", null ],
      [ "Damage Masks", "enumerations.html#enumerations_damage", null ]
    ] ],
    [ "GLUT Compatibility", "glut.html", [
      [ "Using the GLUT Compatibility Header File", "glut.html#glut_using", null ],
      [ "Known Problems", "glut.html#glut_known_problems", null ],
      [ "Mixing GLUT and FLTK Code", "glut.html#glut_mixing", null ],
      [ "class Fl_Glut_Window", "glut.html#glut_Fl_Glut_Window", [
        [ "Class Hierarchy", "glut.html#glut_class_hierarchy", null ],
        [ "Include Files", "glut.html#glut_include_files", null ],
        [ "Description", "glut.html#glut_description", null ],
        [ "Members", "glut.html#glut_members", null ],
        [ "Methods", "glut.html#glut_methods", null ]
      ] ]
    ] ],
    [ "Forms Compatibility", "forms.html", [
      [ "Importing Forms Layout Files", "forms.html#forms_importing", null ],
      [ "Using the Compatibility Header File", "forms.html#forms_using", null ],
      [ "Problems You Will Encounter", "forms.html#forms_problems", null ],
      [ "Additional Notes", "forms.html#forms_notes", null ]
    ] ],
    [ "Operating System Issues", "osissues.html", [
      [ "Accessing the OS Interfaces", "osissues.html#osissues_accessing", null ],
      [ "The UNIX (X11) Interface", "osissues.html#osissues_unix", [
        [ "Handling Other X Events", "osissues.html#osissues_x_events", null ],
        [ "Drawing using Xlib", "osissues.html#osissues_drawing_xlib", null ],
        [ "Changing the Display, Screen, or X Visual", "osissues.html#osissues_xvisual", null ],
        [ "Using a Subclass of Fl_Window for Special X Stuff", "osissues.html#osissues_specialx", null ],
        [ "Setting the Icon of a Window", "osissues.html#osissues_x_icon", null ],
        [ "X Resources", "osissues.html#osissues_xresources", null ]
      ] ],
      [ "The Windows (WIN32) Interface", "osissues.html#osissues_win32", [
        [ "Using filenames with non-ASCII characters", "osissues.html#non_ascii_filenames", null ],
        [ "Handling Other WIN32 Messages", "osissues.html#osissues_win32_messages", null ],
        [ "Drawing Things Using the WIN32 GDI", "osissues.html#osissues_win32_gdi", null ],
        [ "Setting the Icon of a Window", "osissues.html#osissues_icon_windows", null ],
        [ "How to Not Get a MSDOS Console Window", "osissues.html#osissues_msdos_console", null ],
        [ "Known WIN32 Bugs and Problems", "osissues.html#osissues_win32_problems", null ]
      ] ],
      [ "The Apple OS X Interface", "osissues.html#osissues_macos", [
        [ "Drawing Things Using Quartz", "osissues.html#osissues_quartz", null ],
        [ "Mac File System Specifics", "osissues.html#osissues_mac_files", null ]
      ] ]
    ] ],
    [ "Migrating Code from FLTK 1.0 to 1.1", "migration_1_1.html", [
      [ "Color Values", "migration_1_1.html#migration_1_1_color", null ],
      [ "Cut and Paste Support", "migration_1_1.html#migration_1_1_cutnpaste", null ],
      [ "File Chooser", "migration_1_1.html#migration_1_1_file_chooser", null ],
      [ "Function Names", "migration_1_1.html#migration_1_1_functions", null ],
      [ "Image Support", "migration_1_1.html#migration_1_1_images", null ],
      [ "Keyboard Navigation", "migration_1_1.html#migration_1_1_keyboard", null ]
    ] ],
    [ "Migrating Code from FLTK 1.1 to 1.3", "migration_1_3.html", [
      [ "Migrating From FLTK 1.0", "migration_1_3.html#migration_1_3_fltk_1_0", null ],
      [ "Fl_Scroll Widget", "migration_1_3.html#migration_1_3_fl_scroll", null ],
      [ "Unicode (UTF-8)", "migration_1_3.html#migration_1_3_unicode", null ],
      [ "Widget Coordinate Representation", "migration_1_3.html#migration_1_3_int_coords", null ]
    ] ],
    [ "Developer Information", "development.html", [
      [ "Non-ASCII Characters", "development.html#development_non-ascii", null ],
      [ "Document Structure", "development.html#development_structure", null ],
      [ "Creating Links", "development.html#development_links", null ],
      [ "Paragraph Layout", "development.html#development_paragraphs", null ],
      [ "Navigation Elements", "development.html#development_navigation_test", null ]
    ] ],
    [ "Software License", "license.html", null ],
    [ "Example Source Code", "examples.html", [
      [ "Example Applications", "examples.html#example_applications", [
        [ "adjuster", "examples.html#examples_adjuster", null ],
        [ "arc", "examples.html#examples_arc", null ],
        [ "ask", "examples.html#examples_ask", null ],
        [ "bitmap", "examples.html#examples_bitmap", null ],
        [ "blocks", "examples.html#examples_blocks", null ],
        [ "boxtype", "examples.html#examples_boxtype", null ],
        [ "browser", "examples.html#examples_browser", null ],
        [ "button", "examples.html#examples_button", null ],
        [ "buttons", "examples.html#examples_buttons", null ],
        [ "checkers", "examples.html#examples_checkers", null ],
        [ "clock", "examples.html#examples_clock", null ],
        [ "colbrowser", "examples.html#examples_colbrowser", null ],
        [ "color_chooser", "examples.html#examples_color_chooser", null ],
        [ "cube", "examples.html#examples_cube", null ],
        [ "CubeView", "examples.html#examples_CubeView", null ],
        [ "cursor", "examples.html#examples_cursor", null ],
        [ "curve", "examples.html#examples_curve", null ],
        [ "demo", "examples.html#examples_demo", null ],
        [ "device", "examples.html#examples_device", null ],
        [ "doublebuffer", "examples.html#examples_doublebuffer", null ],
        [ "editor", "examples.html#examples_editor", null ],
        [ "fast_slow", "examples.html#examples_fast_slow", null ],
        [ "file_chooser", "examples.html#examples_file_chooser", null ],
        [ "fonts", "examples.html#examples_fonts", null ],
        [ "forms", "examples.html#examples_forms", null ],
        [ "fractals", "examples.html#examples_fractals", null ],
        [ "fullscreen", "examples.html#examples_fullscreen", null ],
        [ "gl_overlay", "examples.html#examples_gl_overlay", null ],
        [ "glpuzzle", "examples.html#examples_glpuzzle", null ],
        [ "hello", "examples.html#examples_hello", null ],
        [ "help", "examples.html#examples_help", null ],
        [ "iconize", "examples.html#examples_iconize", null ],
        [ "image", "examples.html#examples_image", null ],
        [ "inactive", "examples.html#examples_inactive", null ],
        [ "input", "examples.html#examples_input", null ],
        [ "input_choice", "examples.html#examples_input_choice", null ],
        [ "keyboard", "examples.html#examples_keyboard", null ],
        [ "label", "examples.html#examples_label", null ],
        [ "line_style", "examples.html#examples_line_style", null ],
        [ "list_visuals", "examples.html#examples_list_visuals", null ],
        [ "mandelbrot", "examples.html#examples_mandelbrot", null ],
        [ "menubar", "examples.html#examples_menubar", null ],
        [ "message", "examples.html#examples_message", null ],
        [ "minimum", "examples.html#examples_minimum", null ],
        [ "navigation", "examples.html#examples_navigation", null ],
        [ "output", "examples.html#examples_output", null ],
        [ "overlay", "examples.html#examples_overlay", null ],
        [ "pack", "examples.html#examples_pack", null ],
        [ "pixmap_browser", "examples.html#examples_pixmap_browser", null ],
        [ "pixmap", "examples.html#examples_pixmap", null ],
        [ "preferences", "examples.html#examples_preferences", null ],
        [ "radio", "examples.html#examples_radio", null ],
        [ "resizebox", "examples.html#examples_resizebox", null ],
        [ "resize", "examples.html#examples_resize", null ],
        [ "scroll", "examples.html#examples_scroll", null ],
        [ "shape", "examples.html#examples_shape", null ],
        [ "subwindow", "examples.html#examples_subwindow", null ],
        [ "sudoku", "examples.html#examples_sudoku", null ],
        [ "symbols", "examples.html#examples_symbols", null ],
        [ "tabs", "examples.html#examples_tabs", null ],
        [ "threads", "examples.html#examples_threads", null ],
        [ "tile", "examples.html#examples_tile", null ],
        [ "tiled_image", "examples.html#examples_tiled_image", null ],
        [ "valuators", "examples.html#examples_valuators", null ],
        [ "fluid", "examples.html#examples_fluid", null ]
      ] ]
    ] ],
    [ "FAQ (Frequently Asked Questions)", "FAQ.html", [
      [ "Where do I start learning FLTK?", "FAQ.html#faq_start", null ],
      [ "How do a make a box with text?", "FAQ.html#faq_box_with_text", null ],
      [ "Can I use FLTK to make closed-source commercial applications?", "FAQ.html#faq_license", null ],
      [ "Hitting the 'Escape' key closes windows - how do I prevent this?", "FAQ.html#faq_escape", null ]
    ] ],
    [ "Todo List", "todo.html", null ],
    [ "Deprecated List", "deprecated.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", null ],
        [ "Typedefs", "functions_type.html", null ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", "globals_func" ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"Enumerations_8H.html",
"Enumerations_8H.html#ad16daf120d9a0501cccaee563af0b9a3aed9d7c8fbb9dac1e16f762195f00d5d6",
"Fl__Repeat__Button_8H_source.html",
"classFl__Browser.html#ab104eab731c1d2036efb84a628b2dd55",
"classFl__End.html",
"classFl__Graphics__Driver.html#a259fc45a0997b1bae7660c01af943457",
"classFl__Image.html#a99d3fbb860c18cfc9d29c7b2426cc348",
"classFl__PNG__Image.html",
"classFl__Preferences.html#a7e2ec1496b7eb3cc5b2b9e8f6584c979",
"classFl__Spinner.html#ae0e2090c56614e15d75de2f7ac13b0cc",
"classFl__Text__Buffer.html#a6b458132afd9a331b0254321b2e28b42",
"classFl__Text__Editor.html#a6d8e782a3c24702868d568c0fba226c3",
"classFl__Tree__Item.html#a7beef0278b48b70d909b50588b58a328",
"classFl__Widget.html#a991d448d9a42fb926819defc9de90999",
"common.html#common_groups",
"fl__color_8cxx.html#a7298565818edf6f7664c2a2fdc9b2cb9",
"functions_0x6a.html",
"group__fl__drawings.html#ga035deb6aa074fd5df1419412ba370410",
"group__fl__unicode.html#ga56a6296024debb49690b81addda7589b",
"structFl__Help__Font__Stack.html#af931d5b3f964f60604fa418445b1fffb"
];

var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  return 'localStorage' in window && window['localStorage'] !== null;
}

function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode) {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  imgNode.width = 16;
  imgNode.height = 22;
  if (level==0 && node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast) {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        } else {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  } else {
    domNode.appendChild(imgNode);
  }
  if (level==0) {
    if (node.isLast) {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    } else {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2pnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  } else {
    if (node.isLast) {
      imgNode.src = node.relpath+"ftv2blank.png";
    } else {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : '#';
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var pos, anchor = $(aname), docContent = $('#doc-content');
        if (anchor.parent().attr('class')=='memItemLeft') {
          pos = anchor.parent().position().top;
        } else if (anchor.position()) {
          pos = anchor.position().top;
        }
        if (pos) {
          var dist = Math.abs(Math.min(
                     pos-docContent.offset().top,
                     docContent[0].scrollHeight-
                     docContent.height()-docContent.scrollTop()));
          docContent.animate({
            scrollTop: pos + docContent.scrollTop() - docContent.offset().top
          },Math.max(50,Math.min(500,dist)),function(){
            window.location.replace(aname);
          });
        }
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var anchor = $($(location).attr('hash'));
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (root==NAVTREE[0][1]) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    navSync.html('<img src="'+relpath+'sync_off.png"/>');
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    navSync.html('<img src="'+relpath+'sync_on.png"/>');
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      navSync.html('<img src="'+relpath+'sync_off.png"/>');
      navSync.removeClass('sync');
    } else {
      navSync.html('<img src="'+relpath+'sync_on.png"/>');
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     }
  })

  $(window).load(showRoot);
}

